int XC2dWI_calresd_WTmf(float *dobs, float *dcal, float *dres, float *vsrc, int needvsrc, int n1, int n2, float thresd)
{
   int i1,i2,idx,itlag;
   //float *tr1,*tr2, *xcorr;
   int ntlag,ntlag1;
   float maxval,alpha;
   double sum,pi,sum1,sum2;
   float val1;
   int maxidx,sz,stat,sz1;
   float *tlag,*xcorr,*tr1,*tr2;
   ntlag=30;
   ntlag1=3;

   sz=3; //size of the median filter
   pi=3.14159265358979;
   tr1=(float*)malloc(sizeof(float)*n1);
   tr2=(float*)malloc(sizeof(float)*n1);
   tlag=(float*)malloc(sizeof(float)*(n2+sz+5));
   xcorr=(float*)malloc(sizeof(float)*(2*ntlag+1));
   for (i2=0;i2<n2;i2++)//Spans all receivers/
   {
      for (i1=0;i1<2*ntlag+1;i1++)
         xcorr[i1]=0;
      for (i1=0;i1<n1;i1++)
         tr1[i1]=dcal[i1+i2*n1];
      
      /********negative lags***********/
      for (itlag=-ntlag;itlag<1;itlag++)
      {
         for (i1=0;i1<n1;i1++)
            tr2[i1]=0;
         for (i1=0;i1<n1+itlag;i1++)
            tr2[i1]=dobs[i1-itlag+i2*n1];
         for (i1=0;i1<n1;i1++)
            xcorr[itlag+ntlag]+=tr1[i1]*tr2[i1];
      }
      /********positive lags***********/
      for (itlag=1;itlag<ntlag;itlag++)
      {
         for (i1=0;i1<n1;i1++)
            tr2[i1]=0;
         for (i1=itlag;i1<n1;i1++)
            tr2[i1]=dobs[i1-itlag+i2*n1];
         for (i1=0;i1<n1;i1++)
            xcorr[itlag+ntlag]+=tr1[i1]*tr2[i1];
      }
      /////////////////////////
      // for QC xcorr panel
      /*if (needvsrc>0)
      {
          for (idx=i2*n1;idx<i2*n1+2*ntlag+1;idx++)
             vsrc[idx]=xcorr[idx-i2*n1];
      }*/
      /////////////////////////

/************Picking lag of maximum xcorrelation***************/
      maxval=thresd*0.1;
      maxidx=0;
      for (itlag=0;itlag<2*ntlag+1;itlag++)
      {
         if (xcorr[itlag]>maxval)
         {
            maxval=xcorr[itlag];
            maxidx=itlag-ntlag;
         }
      }
      /*For filtering purposes
      size of *tlag is n2+sz.
      Delta_Tau for each receiver is stored in i2=[(sz-1)/2,n2-(sz-1)/2-1].
      Then the tapers on the beginning and on the end are padded as:
      For i2=[0,(sz-1)/2] tlag[i2]=tlag[(sz-1)/2]
      For i2=[n2-(sz-1)/2,n2-1] tlag[i2]=tlag[n2-(sz-1)/2-1]*/
      tlag[i2+(sz-1)/2]=maxidx;
   }
   for (i2=0;i2<(sz-1)/2;i2++)
   {
       tlag[i2]=tlag[(sz-1)/2];
       tlag[n2+(sz-1)/2+i2]=tlag[n2+(sz-1)/2-1];
   }
   
   for (i2=0;i2<n2;i2++)
   {


/*************Application of median filter to maxid (lag that maximizes xcorrelation) along receivers**************/
      //stat=XC3dWI_MedianFilter(&tlag[i2], sz, &tlag[i2+(n2+sz)+(sz-1)/2]);
      if (i2<(sz-1)/2)
      {
         stat=XC2dWI_MedianFilter(&tlag[(sz-1)/2], sz, &maxidx);
         if (maxidx<0 && tlag[i2+(sz-1)/2] <0)
            maxidx=max(maxidx,tlag[i2+(sz-1)/2]);
         if (maxidx>0 && tlag[i2+(sz-1)/2] >0)
            maxidx=min(maxidx,tlag[i2+(sz-1)/2]);
      }
      else if (i2<n2-((sz-1)/2))
         stat=XC2dWI_MedianFilter(&tlag[i2], sz, &maxidx);
      else
      {
         stat=XC2dWI_MedianFilter(&tlag[n2-sz], sz, &maxidx);
         if (maxidx<0 && tlag[i2+(sz-1)/2] <0)
            maxidx=max(maxidx,tlag[i2+(sz-1)/2]);
         if (maxidx>0 && tlag[i2+(sz-1)/2] >0)
            maxidx=min(maxidx,tlag[i2+(sz-1)/2]);
      }
        
      if (stat==1)
      {
         fprintf(stderr,"Error calling XC2dWI_MedianFilter in XC2dWI_calresd_WTmf, return\n");
         return 1;
      }
      if (tlag[i2+(sz-1)/2]==0)
         maxidx=0;
      else
      {
/*************Cross-correlation around the median filter result**************/
         for (i1=0;i1<2*ntlag+1;i1++)
            xcorr[i1]=0;
         for (i1=0;i1<n1;i1++)
            tr1[i1]=dcal[i1+i2*n1];
         //this "for" makes sure itlag is greater than -ntlag
         for (itlag=max(maxidx-ntlag1,-ntlag);itlag<min(1,maxidx+ntlag1);itlag++)
         {
            for (i1=0;i1<n1;i1++)
               tr2[i1]=0;
            for (i1=0;i1<n1+itlag;i1++)
               tr2[i1]=dobs[i1-itlag+i2*n1];
            for (i1=0;i1<n1;i1++)
               xcorr[itlag+ntlag]+=tr1[i1]*tr2[i1];
         }
         //this "for" makes sure itlag is smaller than +ntlag
         for (itlag=max(1,maxidx-ntlag1);itlag<min(ntlag,maxidx+ntlag1);itlag++)
         {
            for (i1=0;i1<n1;i1++)
               tr2[i1]=0;
            for (i1=itlag;i1<n1;i1++)
               tr2[i1]=dobs[i1-itlag+i2*n1];
            for (i1=0;i1<n1;i1++)
               xcorr[itlag+ntlag]+=tr1[i1]*tr2[i1];
         }
/************Picking lag of maximum xcorrelation***************/
         maxval=thresd*0.1;
         maxidx=0;
         for (itlag=0;itlag<2*ntlag+1;itlag++)
         {
            if (xcorr[itlag]>maxval)
            {
               maxval=xcorr[itlag];
               maxidx=itlag-ntlag;
            }
         }
      }
/************Taking time derivative of synthetic trace***************/
      for (i1=0;i1<n1-1;i1++)
         tr1[i1]=dcal[i1+1+i2*n1]-dcal[i1+i2*n1];
      tr1[n1-1]=0;

      for (i1=0;i1<n1;i1++)
         tr2[i1]=0;

/************Taking time derivative of observed trace shifted by maxidx (lag that maximizes xcorrelation)***************/
      if (maxidx>0)
      {
         for (i1=maxidx;i1<n1-1;i1++)
            tr2[i1]=dobs[i1+1-maxidx+i2*n1]-dobs[i1-maxidx+i2*n1];
      }
      else
      {
         for (i1=0;i1<n1-1+maxidx;i1++)
            tr2[i1]=dobs[i1+1-maxidx+i2*n1]-dobs[i1-maxidx+i2*n1];
      }

      /****************************************
      coefficient E defined in equation (9) of paper by
      Luo and Schuster, Wave-equation traveltime inversion, 1991.
      *****************************************/
      sum=0;
      for (i1=0;i1<n1;i1++)
         sum+=tr1[i1]*tr2[i1];

      sum2=0;
      for (i1=0;i1<n1;i1++)
         sum2+=tr1[i1]*tr1[i1];

      sum1=0;
      for (i1=0;i1<n1;i1++)
         sum1+=fabsf(dobs[i1+i2*n1]);

      //fprintf(stderr,"sum1=%f\n",sum1);
      
      for (i1=0;i1<n1;i1++)
      {
         idx=i1+i2*n1;
         if (fabs(sum1)<thresd)
            dres[idx]=0;
         else
         {
            if (i1==0)
               dres[idx]=(float)((1.*tlag[i2+(sz-1)/2])/(100*n1));
            else
               dres[idx]=(float)((1.*maxidx)/n1);
         }

         if (needvsrc>0)
         {
            if (fabs(sum1)<thresd)
               vsrc[idx]=0;
            else
               vsrc[idx]=(1./sum2)*tr1[i1]*maxidx;
         }
      }
   }
   free(tlag);
   free(xcorr);
   free(tr1);
   free(tr2);
   return 0;

}

int XC2dWI_MedianFilter(float *array, int sz, int *med)
{
    int i1,i2;
    float tmp;
    float a[30];
    if (sz>30)
    {
       fprintf(stderr,"Error, can't handle array bigger than 30 in XC2dWI_MedianFilter\n");
       return 1;
    }
    for (i1=0;i1<sz;i1++)
       a[i1]=array[i1];
    for (i1=0;i1<sz-1;i1++)
    {
       for (i2=sz-1;i2>i1;i2--)
       {
         if (a[i2-1]>a[i2])
         {
            tmp=a[i2-1];
            a[i2-1]=a[i2];
	    a[i2]=tmp;
         }
       }
    }   
    *med=a[((int)((sz-1)/2))];

    return 0;
}
