#!/bin/tcsh
#PBS -N 2dseam
#PBS -l nodes=33:ppn=16
#PBS -q default
#PBS -V
#PBS -e /data/sep/xukai/huo1/2dWI_bpait/test11dd2.err
#PBS -o /data/sep/xukai/huo1/2dWI_bpait/test11dd2.out
#
cd $PBS_O_WORKDIR
#

set DATDIR=/data/sep/xukai/data/test/bpait
set CBIN=/data/sep/xukai/Bin/c1

cat ${PBS_NODEFILE} | sort | uniq > hostfile2
set NPROCS=`wc -l hostfile2 | gawk '//{print $1}'`
echo ${NPROCS}
set OMP_NUM_THREADS=8
#mpirun -machinefile ./hostfile2 -np ${NPROCS} ./test_mpi.x

set str=111dd2

date

mpirun -machinefile ./hostfile2 -np ${NPROCS} ${CBIN}/XC2dWIMPIMain.x <tmprcd2bp1.H nxtape=60 nztape=60 vmin=600 vmax=4520 vout=${DATDIR}/newvel${str}.H resd=${DATDIR}/resd${str}.H vupd=${DATDIR}/vup${str}.H rdful=${DATDIR}/rdful${str}.H newsrc=${DATDIR}/newsrc${str}.H needspline=0 niter=60 needprecond=1 dxspline=50 dzspline=50 vel=vel3s5.H jrdful=9 jtmv=1 objtype=0 src=tmpsrc1bp1.H thresd=0.0015 jnoderdful=1 rndbnd_type=2 j_rndbnd=5 alpha_mean=-0.03 alpha_sigma=0.05 alpha_maxV=0.0 sigma=600 rdfulpath=/data/sep/xukai/huo1/2dWI_bpait/rdful${str}-inode- gradfulpath=/data/sep/xukai/huo1/2dWI_bpait/gradful${str}-inode- sdep=sdep.H rdep=sdep.H  dwht=tmpdwht21.H

date
