# include SEP rules

# define related directories
RESDIR = Fig
mydir=./
FBIN = ${mydir}/Bin/f
CBIN = ${mydir}/Bin/c
FOBJ = ${mydir}/Obj
COBJ = ${mydir}/Obj
SRCDIR = ${mydir}/Src/2dISO
RESULTSER =
RESULTSCR =
RESULTSNR = 
#FFTWLIBS = -L/opt/FFTW/lib/ -lfftw3f
#UF90LIBS = -lsepgeef90 -lsep2df90 -lsep3df90 -lsep3d -lsepf90 -lsep -lsupersetf90 -lsuperset -lsep -lsepauxf90 ${FFTWLIBS}
#UF90INCLUDES = -I.
#UF90FLAGS = -CB



######################################################################################################################
FCOLEVEL = 3
MAIN_LIBS=-lsep2df90
SEPstuff= -I ${SEP}/include/  -L ${SEP}/lib
#FFTWLIBS = -L/opt/FFTW/lib/ -lfftw3f -L${mydir}/lib/ -lfftw3

#UF90INCLUDES=-I. -I${MPIDIR}/include/${CUINCPATH}
#UF90LIBS= -lsepauxf90 -lsepmathf90  -L${MPIDIR}/lib ${MAIN_LIBS} ${SEPstuff} ${FFTWLIBS} ${CULIBPATH} ${CULIBS}
UF90LIBS= -lsepauxf90 -lsepmathf90  ${MAIN_LIBS} ${SEPstuff} 
CCEFLAGS=  -L/lib64 -I/slc/csd/intel/compilers/11.0_x86_64/include -L/slc/csd/intel/compilers/11.0_x86_64/lib/intel64
SEPINCDIR = ${SEP}/include
SEPLIBDIR = ${SEP}/lib
#SEPLIBS = -lsuperset -lsep3d -lsep -lm 
SEPLIBS =  -lsuperset -lsepauxf90 -lsep2df90 -lsep3df90 -lsep3d -lsepf90 -lsep 
#MYINC = -I ${mydir}/Src/ -I ${mydir}/Src/3dstencil/ -I ${mydir}/Src/2dstencil/ -I ${mydir}/Src/GA/ -I ${mydir}/FFTW/include -I ${mydir}/Obj/f/
MYINC = -I ${SRCDIR}/ -I ${SRCDIR}/2dstencil   -I /opt/FFTW/include/  -I ${FOBJ}
MYLIBS = -L/opt/FFTW/lib -lfftw3f 
FLAGS = -O2 -openmp
GCC=gcc
ICC=icc
MPICC=mpicc
FC=ifort
ALLFLAG= ${FLAGS} -I ${SEPINCDIR} -L${SEPLIBDIR} ${SEPLIBS} ${MYINC} ${MYLIBS} ${CCEFLAGS}

${COBJ}/%.o:${SRCDIR}/%.c 
	${ICC} -c ${SRCDIR}/$*.c ${ALLFLAG}  -o $@

${CBIN}/%.x:${COBJ}/%.o 
	${ICC} ${COBJ}/$*.o ${ALLFLAG}
	mv a.out $@


${FOBJ}/%.o:${SRCDIR}/%.f90  
	${FC} -c ${SRCDIR}/$*.f90 ${ALLFLAG}  -o $@

${FOBJ}/%.mod:${SRCDIR}/%.f90 
	${FC} -c ${SRCDIR}/$*.f90 ${ALLFLAG}  -o $@

${FBIN}/%.x:${FOBJ}/%.o  ${FOBJ}/billgen.o 
	${FC} ${FOBJ}/billgen.o ${FOBJ}/$*.o ${ALLFLAG} 
	mv a.out $@


